// Header File
// Created 09.05.2011; 23:13:23

//Int32 mul_16_16( Int16 a, Int16 b );



#ifdef WIN32

#define mul_16_16( a, b ) ( (Int32)((Int16)(a)) * (Int32)((Int16)(b)) )
#define mul_u16_u16( a, b ) ( (UInt32)((UInt16)(a)) * (UInt32)((UInt16)(b)) )
#define div_16_16( a, b ) ( (Int16)((Int16)(a)) / (Int32)((Int16)(b)) )
#define div_u16_u16( a, b ) ( (UInt16)((UInt16)(a)) / (UInt32)((UInt16)(b)) )

#define mul_16_u16( a, b ) ( ( (Int32)((Int16)(a)) * ((Int32)((UInt16)(b))) ) >> 16 )
#define mul_32_u32( a, b ) ( (Int32)(( ((long long)(a)) * ((long long)(b)) ) >> 16) )
#define mul_32_u16( a, b ) ( (Int32)(( ((long long)(a)) * ((long long)((UInt16)(b))) ) >> 16) )
#define mul_16_u32( a, b ) ( (Int32)(( ((Int16)(a)) * ((long long)(b)) ) >> 16) )
#define mul_16_u32_ns( a, b ) ( (Int32)( ((long long)((Int16)(a))) * ((long long)((UInt32)(b))) ) )
#define mul_u16_32_ns( a, b ) ( (Int32)( ((long long)((UInt16)(a))) * ((long long)((Int32)(b))) ) )

#define div_32_u16( n, d ) ( (Int32)( (((long long)(n))) / ( long long )((UInt16)(d)) ) )
#define div_u32_u16( n, d ) ( (Int32)( (((unsigned long long)n)) / ((UInt16)(d)) ) )


#else

#define mul_16_16( a, b )	\
({ Int32 prod; Int16 arg1=(a),arg2=(b);   \
__asm__ ( "muls.w %2,%0" : "=d" ( prod ) : "0" ( arg1 ), "d" ( arg2 ) );	\
prod; } )

#define mul_u16_u16( a, b )	\
({ UInt32 prod; UInt16 arg1=(a), arg2=(b);   \
__asm__ ( "mulu.w %2,%0;" : "=d" ( prod ) : "0" ( arg1 ), "d" ( arg2 ) );	\
prod; } )

Int16 mul_16_u16( Int16 sa1, UInt16 a2 );
Int16 mul_16_u16_r( Int16 sa1, UInt16 a2 );
Int32 mul_32_u32( Int32 sa1, UInt32 a2 );
Int32 mul_16_u32( Int16 sa1, UInt32 a2 );
Int32 mul_16_u32_ns( Int16 sa1, UInt32 a2 );
Int32 mul_32_u16( Int32 sa1, UInt16 a2 );
Int32 mul_u16_32_ns( UInt16 a1, Int32 sa2 );


UInt32 div_u32_u16( UInt32 n, UInt16 d );
UInt32 div_32_u16( UInt32 n, UInt16 d );
UInt32 div_persp( UInt32 d );

#endif

Int16 acos_d8( engine_t *ps_eng, Int16 i_angle );
deg8_t angle_vector( engine_t *ps_eng, vec2_t v );
void rand_init( engine_t *ps_eng );
UInt16 rand16( engine_t *ps_eng );



