// C Source File
// Created 30.05.2011; 20:39:11

#include "eng.h"

//#include "mapc.h"

Int16 map_load( engine_t *ps_eng, Int16 i16_map )
{
	void *p_loaded_map;
	map_t *ps_map, *ps_rmap_header;
	repository_map_t *ps_rmap;

	ps_rmap = &ps_eng->s_repository.rgs_maps[ i16_map ];

	if( ps_eng->ui16_size_for_map < ps_rmap->i_map_length )
	{
		return 0;
	}

	p_loaded_map = ps_eng->p_memory_for_map;

	repo_get_map( ps_eng, i16_map, p_loaded_map );

	ps_rmap_header = ( map_t * ) p_loaded_map;

	ps_eng->s_map = *ps_rmap_header; /* get header */
	ps_eng->s_map.p_loaded_map = p_loaded_map;
	ps_map = &ps_eng->s_map;

	ps_map->p_vertices = ( vec2_t *)( ( &ps_rmap_header->i_padding ) + 1 );
	ps_map->p_planes = ( plane_t *)( ps_map->p_vertices + ps_map->i_num_vertices );
	ps_map->p_lines = ( line_t * )( ps_map->p_planes + ps_map->i_num_planes );
	ps_map->p_sectors = ( sector_t *)( ps_map->p_lines + ps_map->i_num_lines );
	ps_map->p_nodes = ( node_t *)( ps_map->p_sectors + ps_map->i_num_sectors );
	ps_map->p_entities = ( mentity_t *)( ps_map->p_nodes + ps_map->i_num_nodes );
	ps_map->rgpui8_textures = ( UInt8 (*)[16] )( ps_map->p_entities + ps_map->i_num_entities );
	ps_map->pui8_visibility = ( UInt8 * )( ps_map->rgpui8_textures + ps_map->i_num_textures );
	ps_map->p_connectors = ( connector_t *)( ps_map->pui8_visibility + ps_map->i_num_visibility );
	ps_map->pi_connections = ( UInt16 * ) (ps_map->p_connectors + ps_map->i_num_connectors );
	ps_map->pui8_connection_distance = ( UInt8 * )( ps_map->pi_connections + ps_map->i_num_connector_connections );
	ps_map->p_clipnodes = ( clipnode_t * )( ps_map->pui8_connection_distance + ps_map->i_num_connector_connections );
	ps_eng->pui16_sector_entities = ( UInt16 * )( ps_map->p_clipnodes + ps_map->i_num_clip_nodes );
	

	return 1;
}


Int16 map_point_plane_dist( engine_t *ps_eng, plane_t *p_plane, vec2_t v1 )
{
	return ( ( ( ( Int32 )v1[ 0 ] * ps_eng->s_map.p_vertices[ p_plane->i_normal ][ 0 ] ) + 0x4000 ) >>15 ) + ( ( ( ( Int32 )v1[ 1 ] * ps_eng->s_map.p_vertices[ p_plane->i_normal ][ 1 ] ) + 0x4000 ) >> 15 ) - p_plane->i_length;
}


