// Header File
// Created 05.05.2011; 20:18:46


typedef UInt8 deg8_t;
typedef Int16 frac16_t;
typedef Int16 fixed4_t;
typedef Int32 fixed16_t;

typedef fixed4_t vec2_t[2];
typedef fixed4_t vec3_t[3];
typedef frac16_t normal_t[3];

typedef struct {
	normal_t front;
	normal_t right;
	vec3_t translation;
}transform_t;

#define ONE_F4  (1<<4)
#define ONE_F16 (1<<16)


#define sin_d8( ps_eng, r ) ( ps_eng->rgi16_cosine_table[(r) & 0xff] )
#define cos_d8( ps_eng, r ) ( ps_eng->rgi16_cosine_table[(((int)(r))+0x40) & 0xff] )

#define load_vector( v, x, y, z ) do { v[0] = x; v[1] = y; v[2] = z; } while( 0 )
#define load_vector2( v, x, y ) do { v[0] = x; v[1] = y; } while( 0 )

#define load_vector2v( v, vs ) do { v[ 0 ] = vs[ 0 ]; v[ 1 ] = vs[ 1 ]; } while( 0 )

Int32 dot_16( vec2_t v1, vec2_t v2 );

void transform_vec2( vec2_t v1, transform_t *t, vec2_t dst );



UInt32 isqrt( UInt32 i_ui );
