// C Source File
// Created 28.05.2011; 23:12:14

#include "eng.h"

void generate_texture_mapping_table( engine_t *ps_eng )
{
	Int16 i_idx;

	i_idx = 0;
	while( i_idx < ps_eng->s_map.i_num_textures )
	{
		ps_eng->rgui8_texture_mapping_table[ i_idx ] = repo_get_texture_idx( ps_eng, &ps_eng->s_map.rgpui8_textures[ i_idx ][ 0 ] );
		i_idx++;
	}
	ps_eng->ps_texture_cache->i_num_cached_textures = 0;
	ps_eng->ps_texture_cache->i_lru_counter = 0;
}

UInt8 *texture_get( engine_t *ps_eng, Int16 i_map_idx )
{
	Int16 i_idx, i_lowidx;
	Int16 i_low;
	cached_texture_t *ps_ctex;


	i_low = 0;
	i_lowidx = 0;
	for( i_idx = 0; i_idx < ps_eng->ps_texture_cache->i_num_cached_textures; i_idx++ )
	{
		Int16 i_tlow;
		if( ps_eng->ps_texture_cache->rgs_textures[ i_idx ].i_idx == i_map_idx )
		{
			ps_eng->ps_texture_cache->rgs_textures[ i_idx ].i_lru = ps_eng->ps_texture_cache->i_lru_counter++;
			return &ps_eng->ps_texture_cache->rgs_textures[ i_idx ].rgui8_texture_data[ 0 ];
		}
		i_tlow = ps_eng->ps_texture_cache->i_lru_counter - ps_eng->ps_texture_cache->rgs_textures[ i_idx ].i_lru;
		if( i_tlow > i_low )
		{
			i_low = i_tlow;
			i_lowidx = i_idx;
		}
	}

	if( i_idx >= TEXTURE_CACHE_SIZE )
	{

	}
	else
	{
		i_lowidx = ps_eng->ps_texture_cache->i_num_cached_textures++;
	}

	ps_ctex = &ps_eng->ps_texture_cache->rgs_textures[ i_lowidx ];
	ps_ctex->i_idx = i_map_idx;
	ps_ctex->i_lru = ps_eng->ps_texture_cache->i_lru_counter++;
	repo_get_texture( ps_eng, ps_eng->rgui8_texture_mapping_table[ i_map_idx ], &ps_ctex->rgui8_texture_data[ 0 ] );

	return &ps_ctex->rgui8_texture_data[ 0 ];
}
